// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.rawData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

function field_name_set(field_name = '', callback){
    chrome.storage.local.set({field_name: field_name}, callback);
}
// Function to convert an image to a Blob
async function imageToBlob(imageUrl) {
  try {
    // Fetch the image as an array buffer
    const response = await fetch(imageUrl);
    const arrayBuffer = await response.arrayBuffer();

    // Create a Blob from the array buffer
    const blob = new Blob([arrayBuffer], { type: response.headers.get("content-type") });

    return blob;
  } catch (error) {
    console.error("Error converting image to Blob:", error);
    return null;
  }
}

// Usage example:
/*const imageUrl = "https://img.kwcdn.com/product/Fancyalgo/VirtualModelMatting/8af63f79afdd388711b1c34289c15cda.jpg?imageView2/2/w/800/q/70/format/webp";
imageToBlob(imageUrl)
  .then(blob => {
    if (blob) {
      // Do something with the Blob, such as uploading it or displaying it
        console.log('aaaa');
        console.log(blob);
    } else {
        console.log("Failed to convert image to Blob.");
    }
  });*/

function urlToBase64(url, callback) {
  const xhr = new XMLHttpRequest();
  xhr.onload = function() {
    const reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

function process_sizeguid(url = ''){
    let _size_guide_html = '';
    $.ajax({
        url: url,
        timeout: 30000, //超时时间设置，单位毫秒
        data: {},
        type: 'GET',
        async: false,
        dataType: 'html',
        contentType: 'text/html; charset=utf-8',
        crossDomain: true,
        cache: false,
        success:function (data){
            console.log('util_ajax_get data');
           // console.log(data);
            let _dom = $(data);
            //
            let scriptdata = util_getscript_pageData_content(data);
            if (scriptdata) {
                scriptdata = scriptdata.trim();
                scriptdata = scriptdata.replace(";document.dispatchEvent(new Event('XRenderInitialPropsLoaded'));", '')
                    .replace("window.__CHUNK_DATA__={};window.rawData=", '');
                console.log('scriptdata process_sizeguid');
                let scriptdata_json = JSON.parse(scriptdata);
                console.log(scriptdata_json);
                //
                if (scriptdata_json && scriptdata_json['store']['sizeGuideStore']) {
                    //
                    let size_productMeasurement = scriptdata_json['store']['sizeGuideStore']['sizeChart']['productMeasurement'];
                    if(size_productMeasurement.length>0){
                        let size_productMeasurement_metasV2 = size_productMeasurement[0]['metasV2'];
                        let size_productMeasurement_recordsInch = size_productMeasurement[0]['recordsInch'];
                        let size_productMeasurement_head_tds = '';
                        for(let _metasV2_key in size_productMeasurement_metasV2){
                            let _className = _metasV2_key == 0?'firstColumn-jbuNf':'';
                            size_productMeasurement_head_tds += "<td className='"+_className+"'>"+size_productMeasurement_metasV2[_metasV2_key]['name']+"</td>";
                        }
                        //
                        let size_productMeasurement_trs = '';
                        for(let _recordsInch_key in size_productMeasurement_recordsInch){
                            let size_productMeasurement_tds = '';
                            //
                            let _recordsInch = size_productMeasurement_recordsInch[_recordsInch_key];
                            let _recordsInch_values = Object.values(_recordsInch);
                            for(let _rvi in _recordsInch_values){
                                let _className = _rvi == 0?'firstColumn-jbuNf':'';
                                size_productMeasurement_tds += "<td className='"+_className+"'>"+_recordsInch_values[_rvi]+"</td>";
                            }
                            //
                            size_productMeasurement_trs += "<tr>"+size_productMeasurement_tds+"</tr>";
                        }
                        //
                        let _size_guid_product_measurements_table = '<div className="tableWrap-34pMC">\n' +
                            '                            <table className="table-2cDcb" cellSpacing="0" cellPadding="0">\n' +
                            '                                <tbody>\n' +
                            '                                <tr className="header-3a-PN">\n' +
                                                                size_productMeasurement_head_tds+
                            '                                </tr>\n' + size_productMeasurement_trs+
                            '                                </tbody>\n' +
                            '                            </table>\n' +
                            '                        </div>';
                        //
                        let _how_to_measure = '';
                        let productInstructions = scriptdata_json['store']['sizeGuideStore']['productInstructions'];
                        if(productInstructions && productInstructions.length>0){
                            let productInstructions_contents = productInstructions[0]['contents'];
                            let productInstructions_imageUrls = productInstructions[0]['imageUrls'];
                            let _label_1qHkws = '';
                            for(let _pci in productInstructions_contents){
                                _label_1qHkws += '<div class="label-1qHkw">'+productInstructions_contents[_pci]['name']+'</div><div class="desc-3per-">'+productInstructions_contents[_pci]['desc']+'</div>';
                            }
                            let _imgWrap_2KYQA = '';
                            if(productInstructions_imageUrls.length>0){
                                _imgWrap_2KYQA = '<div class="imgWrap-2KYQA"><img data-cui-image="1" data-state="succ" class="new-cui-img-wxWpA " src="'+productInstructions_imageUrls[0]+'" data-did-mount="1"></div>';
                            }
                            _how_to_measure = '<div class="wrap-1Rrdr">' +
                            '<div class="title-3DUQW">'+productInstructions[0]['title']+'</div>' +
                                '<div class="content-3143x">' +
                                    '<div class="info-26pAZ">' +_label_1qHkws+'</div>' +
                                    _imgWrap_2KYQA +
                                '</div>' +
                            '</div>';
                        }
                        //body measurements
                        let bodyMeasurement = scriptdata_json['store']['sizeGuideStore']['sizeChart']['bodyMeasurement'];
                        let bodyMeasurement_metasV2 = bodyMeasurement[0]['metasV2'];
                        let bodyMeasurement_recordsInch = bodyMeasurement[0]['recordsInch'];
                        let bodyMeasurement_head_tds = '';
                        for(let _metasV2_key in bodyMeasurement_metasV2){
                            let _className = _metasV2_key == 0?'firstColumn-jbuNf':'';
                            bodyMeasurement_head_tds += "<td className='"+_className+"'>"+bodyMeasurement_metasV2[_metasV2_key]['name']+"</td>";
                        }
                        //
                        let bodyMeasurement_trs = '';
                        for(let _recordsInch_key in bodyMeasurement_recordsInch){
                            let bodyMeasurement_tds = '';
                            for(let _metasV2_key in bodyMeasurement_metasV2){
                                let _className = _metasV2_key == 0?'firstColumn-jbuNf':'';
                                let _bodyMeasurement_recordsInch_id_key = bodyMeasurement_metasV2[_metasV2_key]['id'];
                                bodyMeasurement_tds += "<td className='"+_className+"'>"+bodyMeasurement_recordsInch[_recordsInch_key][_bodyMeasurement_recordsInch_id_key]+"</td>";
                            }
                            //
                            bodyMeasurement_trs += "<tr>"+bodyMeasurement_tds+"</tr>";
                        }
                        //
                        let _bodyMeasurement_table = '<div className="tableWrap-34pMC">\n' +
                            '                            <table className="table-2cDcb" cellSpacing="0" cellPadding="0">\n' +
                            '                                <tbody>\n' +
                            '                                <tr className="header-3a-PN">\n' +
                                                                bodyMeasurement_head_tds+
                            '                                </tr>\n' + bodyMeasurement_trs+
                            '                                </tbody>\n' +
                            '                            </table>\n' +
                            '                        </div>';
                        //
                        let bodyMeasurementTip = scriptdata_json['store']['sizeGuideStore']['bodyMeasurementTip'];
                        let bodyMeasurementTipHtml = '<div class="tip-30gsq" style="color: #aaa;line-height: 18px;margin-bottom:10px;font-size:13px;"><svg viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" width="1em" height="1em" class="icon-4c96R"><path d="M512 39.4c261 0 472.6 211.6 472.6 472.6 0 261-211.6 472.6-472.6 472.6-261 0-472.6-211.6-472.6-472.6 0-261 211.6-472.6 472.6-472.6z m0 72.7c-220.9 0-399.9 179-399.9 399.9 0 220.9 179 399.9 399.9 399.9 220.9 0 399.9-179 399.9-399.9 0-220.9-179-399.9-399.9-399.9z m-72.7 643.1c-20.1 0-36.4-16.3-36.4-36.4 0-17.8 12.9-32.7 29.9-35.7l6.5-0.6 43.4 0 0-195.7-14.3 0c-17.8 0-32.7-12.9-35.8-29.8l-0.5-6.6c0-17.8 12.9-32.7 29.8-35.7l6.5-0.6 50.7 0c17.8 0 32.7 12.9 35.7 29.8l0.6 6.5 0 232.1 29.3 0c20.1 0 36.4 16.3 36.4 36.3 0 17.8-12.9 32.7-29.9 35.8l-6.5 0.6-145.4 0z M502 354.5c32.6 0 59.1-26.4 59.1-59.1 0-32.6-26.4-59.1-59.1-59.1-32.6 0-59.1 26.4-59.1 59.1 0 32.6 26.4 59.1 59.1 59.1z"></path></svg>'+bodyMeasurementTip+'</div>';
                        //
                        let _bodyMeasurement_how_to_measure = '';
                        let bodyInstructions = scriptdata_json['store']['sizeGuideStore']['bodyInstructions'];
                        if(bodyInstructions){
                            let bodyInstructions_contents = bodyInstructions['contents'];
                            let bodyInstructions_imageUrls = bodyInstructions['imageUrls'];
                            let _label_1qHkws = '';
                            for(let _pci in bodyInstructions_contents){
                                _label_1qHkws += '<div class="label-1qHkw">'+bodyInstructions_contents[_pci]['name']+'</div><div class="desc-3per-">'+bodyInstructions_contents[_pci]['desc']+'</div>';
                            }
                            let _imgWrap_2KYQA = '';
                            if(bodyInstructions_imageUrls.length>0){
                                _imgWrap_2KYQA = '<div class="imgWrap-2KYQA"><img data-cui-image="1" data-state="succ" class="new-cui-img-wxWpA " src="'+bodyInstructions_imageUrls[0]+'" data-did-mount="1"></div>';
                            }
                            _bodyMeasurement_how_to_measure = '<div class="wrap-1Rrdr">' +
                            '<div class="title-3DUQW">'+bodyInstructions['title']+'</div>' +
                                '<div class="content-3143x">' +
                                    '<div class="info-26pAZ">' +_label_1qHkws+'</div>' +
                                    _imgWrap_2KYQA +
                                '</div>' +
                            '</div>';
                        }
                        //international size conversions
                        let international_size_conversions = scriptdata_json['store']['sizeGuideStore']['sizeChart']['internationalConversion'];
                        let international_size_conversions_metasV2 = international_size_conversions[0]['metasV2'];
                        let international_size_conversions_recordsInch = international_size_conversions[0]['recordsCm'];
                        let international_size_conversions_head_tds = '';
                        for(let _metasV2_key in international_size_conversions_metasV2){
                            if(_metasV2_key <= 4){
                                 let _className = _metasV2_key == 0?'firstColumn-jbuNf':'';
                                international_size_conversions_head_tds += "<td className='"+_className+"'>"+international_size_conversions_metasV2[_metasV2_key]['name']+"</td>";
                            }
                        }
                        //
                        let bodyinternational_size_conversions_trs = '';
                        for(let _recordsInch_key in international_size_conversions_recordsInch){
                            let bodyMeasurement_tds = '';
                            for(let _metasV2_key in international_size_conversions_metasV2){
                                if(_metasV2_key <= 4){
                                    let _className = _metasV2_key == 0?'firstColumn-jbuNf':'';
                                    let _bodyMeasurement_recordsInch_id_key = international_size_conversions_metasV2[_metasV2_key]['id'];
                                    bodyMeasurement_tds += "<td className='"+_className+"'>"+international_size_conversions_recordsInch[_recordsInch_key][_bodyMeasurement_recordsInch_id_key]+"</td>";
                                }
                            }
                            //
                            bodyinternational_size_conversions_trs += "<tr>"+bodyMeasurement_tds+"</tr>";
                        }
                        //
                        let _international_size_conversions_table = '<div className="tableWrap-34pMC">\n' +
                            '                            <table className="table-2cDcb" cellSpacing="0" cellPadding="0">\n' +
                            '                                <tbody>\n' +
                            '                                <tr className="header-3a-PN">\n' +
                                                                international_size_conversions_head_tds+
                            '                                </tr>\n' + bodyinternational_size_conversions_trs+
                            '                                </tbody>\n' +
                            '                            </table>\n' +
                            '                        </div>';
                        //

                        //
                        _size_guide_html = "<div class='size_guide_wrapper'>";
                         _size_guide_html +="<div class='size_guide_tab'>" +
                            "<div class='size_guide_title' style='margin-bottom:5px;'><strong>Product measurements</strong></div>" +
                            "<div class='size_guide_table' style='margin-bottom: 5px;'>"+_size_guid_product_measurements_table+"</div>"+
                            _how_to_measure+
                        "</div>";
                         //
                          _size_guide_html +="<div class='size_guide_tab'>" +
                            "<div class='size_guide_title' style='margin-bottom:5px;'><strong>Body measurements</strong></div>" +
                            "<div class='size_guide_table' style='margin-bottom:5px;'>"+_bodyMeasurement_table+"</div>"+
                              bodyMeasurementTipHtml+_bodyMeasurement_how_to_measure+
                        "</div>";
                          //
                         _size_guide_html +="<div class='size_guide_tab'>" +
                            "<div class='size_guide_title' style='margin-bottom:5px;'><strong>International size conversions</strong></div>" +
                            "<div class='size_guide_table' style='margin-bottom:5px;'>"+_international_size_conversions_table+"</div>"+
                        "</div>";
                         //
                        _size_guide_html +="</div>";
                    }
                    //
                }
                //
            }
            //
        },
        error: function( jqXHR, textStatus, errorThrown ) {
            console.log('ajax error');
            console.log( jqXHR, textStatus, errorThrown );
        }
    });
    return _size_guide_html;
}

// 使用示例
/*const imageUrl = 'https://example.com/image.jpg'; // 替换为你自己的图片URL
urlToBase64(imageUrl, function(base64String) {
  console.log(base64String); // 这里是Base64编码的图片字符串
});*/
//
function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={}, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                //'_shangjia_name': _shangjia_info['_shangjia_name'],
                //'_shangjia_catalog_1': '',
                //'_shangjia_catalog_2': '',
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],

                '_is_request':0,

                //'_shangjia_img': _shangjia_info['_shangjia_img'],
                //'_shangjia_images': '',
                //'_shangjia_img_blob': '',
                //'_shangjia_price': _shangjia_info['_shangjia_price'],
               // '_shangjia_old_price': _shangjia_info['_shangjia_old_price'],
                //'_shangjia_review_score': _shangjia_info['_shangjia_review_score'],
                //'_shangjia_reivew_num': _shangjia_info['_shangjia_reivew_num'],
                //'_shangjia_sold': _shangjia_info['_shangjia_sold'],
                //'_shangjia_desc':'',

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                //
                '_shangjia_goodsId':'', //sku
                '_shangjia_variants_skus': [], //数组
                '_shangjia_goodsName': '',
                '_shangjia_goodsProperty':'',//description,deschtml
                '_shangjia_description':'',
                '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                '_shangjia_hdThumbUrl': '',//主图
                '_shangjia_gallery':[], //图片列表
                '_shangjia_productDetailFlatList':[],//details imgs
                '_shangjia_category':'',//brumb
                '_shangjia_VideoUrl':'', //video
                //

            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        //need_item['_shangjia_about_contact_and_basic_info_link'] = 'https://www.temu.com/goods.html?_bg_fs=1&goods_id=601099513966458';
        if(need_item['_shangjia_about_contact_and_basic_info_link'] && need_item['_shangjia_about_contact_and_basic_info_link'].indexOf('goods.html') !=-1){
            need_item['_e_time'] = Date.now();
            need_item['_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
            });
            return;
        }
        console.log('request_shangjia_about_contact_and_basic_info_ajax aaa');
        console.log(need_item['_shangjia_about_contact_and_basic_info_link']);
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('data');
               // console.log(data);
               let _dom = $(data);
               //
               let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }
               if(false && util_checkFanpa(_checkContent)){
                   console.log('util_checkFanpa a1');
                   //
                    need_item['_is_request'] = 0;
                    need_item['_error'] = '遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                            //

                            //
                    });
                    pause_s_time();
                    sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
               }else{
                   //console.log('util_checkFanpa a2');
                   //
                   let scriptdata = util_getscript_pageData_content(data);
                   if(scriptdata){
                       scriptdata = scriptdata.trim();
                       scriptdata = scriptdata.replace(";document.dispatchEvent(new Event('XRenderInitialPropsLoaded'));",'')
                           .replace("window.__SSR__=1;window.__CHUNK_DATA__={};window.rawData=",'')
                        .replace("window.__CHUNK_DATA__={};window.rawData=", '');
                       console.log('scriptdata_json a1');
                       let scriptdata_json = JSON.parse(scriptdata);
                       console.log(scriptdata_json);
                       //
                       if(scriptdata_json && scriptdata_json['store']['goodsId']){
                            /*
                            '_shangjia_store_name': '',
                            '_shangjia_store_url': '',
                            '_shangjia_store_items': '',
                            '_shangjia_store_followers': '',
                            '_shangjia_store_sold': '',
                            '_shangjia_store_score': '',
                            '_shangjia_store_review_num':'',
                            //
                            '_shangjia_sold': '',
                             _shangjia_reivew_num
                            '_shangjia_goodsId':'', //sku
                            '_shangjia_variants_skus': [], //数组
                            '_shangjia_goodsName': '',
                            '_shangjia_goodsProperty':'',//description,deschtml
                            '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                            '_shangjia_gallery':[], //图片列表
                            '_shangjia_productDetailFlatList':[],//details imgs
                            '_shangjia_category':'',//brumb
                            '_shangjia_VideoUrl':'', //video
                             */
                           //
                           let _goods_data = scriptdata_json['store']['goods'];
                           if(_goods_data['status'] == 1){
                               let _shangjia_goodsId = scriptdata_json['store']['goodsId'];
                               need_item['_shangjia_goodsId'] = _shangjia_goodsId;

                               let _shangjia_goodsName = _goods_data['goodsName'];
                               need_item['_shangjia_goodsName'] = _shangjia_goodsName;

                               need_item['_shangjia_hdThumbUrl'] = _goods_data['hdThumbUrl'];

                               let _shangjia_minOnSalePriceStr = _goods_data['minOnSalePriceStr'];
                               need_item['_shangjia_minOnSalePriceStr'] = _shangjia_minOnSalePriceStr;

                               let _shangjia_gallery = [];
                               let _shangjia_VideoUrl = '';
                               let _shangjia_gallery_list = _goods_data['gallery'];
                               for(let _i = 0;_i < _shangjia_gallery_list.length; _i++){
                                   _shangjia_gallery.push(_shangjia_gallery_list[_i]['url'])
                                   if(_shangjia_gallery_list[_i]['videoUrl'] && _shangjia_VideoUrl == ''){
                                      _shangjia_VideoUrl = _shangjia_gallery_list[_i]['videoUrl'];
                                   }
                               }
                               need_item['_shangjia_gallery'] = _shangjia_gallery;
                               need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;

                               let _shangjia_goodsProperty ='<ul>';
                               let _shangjia_goodsProperty_list = _goods_data['goodsProperty'];
                               for(let _f=0;_f<_shangjia_goodsProperty_list.length;_f++){
                                   let _shangjia_goodsProperty_item_values = _shangjia_goodsProperty_list[_f]['values'];
                                   let _shangjia_goodsProperty_item_values_str = '';
                                   if(_shangjia_goodsProperty_item_values){
                                       _shangjia_goodsProperty_item_values_str = _shangjia_goodsProperty_item_values.join(', ');
                                   }
                                   _shangjia_goodsProperty += '<li>'+_shangjia_goodsProperty_list[_f]['key']+
                                       ':&nbsp;&nbsp;'+_shangjia_goodsProperty_item_values_str + '</li>';
                               }
                               _shangjia_goodsProperty +='</ul>';
                               need_item['_shangjia_goodsProperty'] = _shangjia_goodsProperty;

                               let _shangjia_productDetailFlatList = [];
                               let _shangjia_productDetailFlatList_Data = scriptdata_json['store']['productDetailFlatList'];
                               if(_shangjia_productDetailFlatList_Data){
                                   for(_j=0;_j<_shangjia_productDetailFlatList_Data.length;_j++){
                                        _shangjia_productDetailFlatList.push(_shangjia_productDetailFlatList_Data[_j]['url']);
                                   }
                               }
                               need_item['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                               //
                                let _description = '';
                                let _scriptdata_store = scriptdata_json['store'];
                                if(_scriptdata_store.hasOwnProperty('description')){
                                    let _description_data = _scriptdata_store['description'];
                                    if(_description_data.hasOwnProperty('items')){
                                        let _description_arr = _description_data['items'];
                                        for(let _description_item_key in _description_arr){
                                            _description += "<div style='padding-bottom: 3px;'>"+_description_arr[_description_item_key]['values']+"</div>";
                                        }
                                    }
                                }
                                if(_description){
                                    _description = '<div class="_description_wrapper">'+_description+'</div>';
                                    need_item['_shangjia_description'] = _description;
                                }
                                //
                               //
                               let _shangjia_category = '';
                               _shangjia_category += _dom.find('._2LmAUJYN nav ol li:eq(1)').text()+ ' > '+ _dom.find('._2LmAUJYN nav ol li:eq(2)').text();
                               need_item['_shangjia_category'] = _shangjia_category;
                               //
                               let _shangjia_variants_skus = [];
                               let _skus = scriptdata_json['store']['sku'];
                               if(_skus && _skus.length > 0){
                                   for(let _i=0;_i<_skus.length;_i++){
                                       //
                                       let _specs = _skus[_i]['specs'];
                                       let specs_key1_name = '';
                                       let specs_key1_value = '';
                                       let specs_key2_name = '';
                                       let specs_key2_value = '';
                                       let specs_key3_name = '';
                                       let specs_key3_value = '';
                                       let specs_key4_name = '';
                                       let specs_key4_value = '';
                                       if(_specs.length ==1){
                                            specs_key1_name = _specs[0]['specKey'];
                                            specs_key1_value = _specs[0]['specValue'];
                                       }else if(_specs.length ==2){
                                            specs_key1_name = _specs[0]['specKey'];
                                            specs_key1_value = _specs[0]['specValue'];

                                            specs_key2_name = _specs[1]['specKey'];
                                            specs_key2_value = _specs[1]['specValue'];
                                       }else if(_specs.length ==3){
                                            specs_key1_name = _specs[0]['specKey'];
                                            specs_key1_value = _specs[0]['specValue'];

                                            specs_key2_name = _specs[1]['specKey'];
                                            specs_key2_value = _specs[1]['specValue'];

                                            specs_key3_name = _specs[2]['specKey'];
                                            specs_key3_value = _specs[2]['specValue'];
                                       }else if(_specs.length ==4){
                                            specs_key1_name = _specs[0]['specKey'];
                                            specs_key1_value = _specs[0]['specValue'];

                                            specs_key2_name = _specs[1]['specKey'];
                                            specs_key2_value = _specs[1]['specValue'];

                                            specs_key3_name = _specs[2]['specKey'];
                                            specs_key3_value = _specs[2]['specValue'];

                                            specs_key4_name = _specs[3]['specKey'];
                                            specs_key4_value = _specs[3]['specValue'];
                                       }
                                       let subsku_specs = '';
                                       if(_specs.length>0){
                                            for(let _j=0;_j<_specs.length;_j++){
                                                //
                                                let _specValue = _specs[_j]['specValue'];
                                                let _specValue_arr = _specValue.split(' ');
                                                //
                                                subsku_specs+=_specValue_arr.join('');
                                            }
                                       }
                                       //
                                       _shangjia_variants_skus.push({
                                            'subsku': _skus[_i]['goodsId']+subsku_specs,
                                            'normalPriceStr': _skus[_i]['normalPriceStr'],
                                            'normalLinePriceStr': _skus[_i]['normalLinePriceStr'],
                                            'img':_skus[_i]['specShowImageUrl'],
                                            'specs_key1_name':specs_key1_name,
                                            'specs_key1_value':specs_key1_value,
                                            'specs_key2_name':specs_key2_name,
                                            'specs_key2_value':specs_key2_value,
                                            'specs_key3_name':specs_key3_name,
                                            'specs_key3_value':specs_key3_value,
                                            'specs_key4_name':specs_key4_name,
                                            'specs_key4_value':specs_key4_value,
                                            'stockQuantity': _skus[_i]['stockQuantity'],
                                            'skuId': _skus[_i]['skuId']
                                       });
                                       //
                                   }
                               }
                               need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                               //'_shangjia_review_score': '',
                               //'_shangjia_reivew_num':'',
                               need_item['_shangjia_sold'] = _goods_data['saleInfo']['sideSalesTip'];
                               //
                                let _reviewStore_data = scriptdata_json['store']['reviewStore'];
                               need_item['_shangjia_reivew_num'] = _reviewStore_data['reviewNum'];
                               need_item['_shangjia_store_review_num'] = _reviewStore_data['mallReviewNum'];
                               //store
                               let _store_data = scriptdata_json['store']['mall']['mallData'];
                               /**
                                * '_shangjia_store_name': '',
                                '_shangjia_store_url': '',
                                '_shangjia_store_items': '',
                                '_shangjia_store_followers': '',
                                '_shangjia_store_sold': '',
                                '_shangjia_store_score': '',
                                */
                               let _shangjia_store_followers = 0;
                               if(_store_data['followerNumUnit'] && _store_data['followerNumUnit'].length>0){
                                    _shangjia_store_followers = _store_data['followerNumUnit'][0];
                               }
                               let  _shangjia_store_sold = 0;
                               if(_store_data['goodsSalesNumUnit'] && _store_data['goodsSalesNumUnit'].length >0){
                                   _shangjia_store_sold = _store_data['goodsSalesNumUnit'][0];
                               }
                               need_item['_shangjia_store_name'] = _store_data['mallName'];
                               need_item['_shangjia_store_url'] = 'https://www.temu.com'+_store_data['seoUrl'];
                               need_item['_shangjia_store_items'] = _store_data['goodsNum'];
                               need_item['_shangjia_store_followers'] = _shangjia_store_followers;
                               need_item['_shangjia_store_sold'] = _shangjia_store_sold;
                               need_item['_shangjia_store_score'] = _store_data['mallStar'];
                               let _store = scriptdata_json['store'];
                               if(_store.hasOwnProperty('sizeGuide')){
                                    console.log('f1');
                                    let _sizeGuide = _store['sizeGuide'];
                                    if(_sizeGuide.hasOwnProperty('jumpUrl')){
                                        console.log('f2');
                                        let _size_guide_url = 'https://www.temu.com/bgc_size_guide.html?goods_id='+_shangjia_goodsId+'&title=Size%20guide&tab=guide&_bg_fs=1';
                                        //let _size_guide_html = process_sizeguid(_size_guide_url);
                                        //
                                       // need_item['_size_guide_html'] = _size_guide_html;
                                        //
                                    }
                                }
                               //
                               need_item['_is_request'] = 2;
                           }else if(_goods_data['status'] == 5 && !_goods_data.hasOwnProperty('goodsName')){ //反爬
                               console.log('scriptdata_json This item is sold out.反爬');
                                need_item['_is_request'] = 0;
                                need_item['_error'] = '';
                                pause_s_time();
                                sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                                //
                           }else{
                               if(!_goods_data.hasOwnProperty('status')){
                                   need_item['_is_request'] = 0;
                                   need_item['_error'] = '';
                                   pause_s_time();
                                   sendPopTips("请检查网络，无法正常访问商品详情页！", need_item['_shangjia_about_contact_and_basic_info_link']);
                                    //
                               }else{
                                   //其它类型的比如购买完了，下架了等
                                   console.log('scriptdata_json 其它类型的比如购买完了，下架了等');
                                   need_item['_is_request'] = 2;
                               }
                           }
                       }else{
                           console.log('scriptdata_json 未发现goods id');
                           need_item['_is_request'] = 0;
                           need_item['_error'] = '';
                           pause_s_time();
                           sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                            //
                       }
                       //
                   }else{
                       console.log('scriptdata_json error');
                       need_item['_is_request'] = 0;
                       need_item['_error'] = '';
                       pause_s_time();
                       sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                        //
                   }

                   /*//
                   if (need_item['_shangjia_name'] == ''){
                       let _shangjia_name = _dom.find('._2Fkk_bmp h1').text();
                       _shangjia_name = _shangjia_name.trim();
                       need_item['_shangjia_name'] = _shangjia_name;
                   }
                   //
                   let _description = _dom.find('._2tVJUTuv').text();
                   if(_description == ''){
                       _description = _dom.find('.B_OB3uj0').text();
                   }
                   need_item['_shangjia_desc'] = _description;
                   need_item['_shangjia_img'] = _dom.find('._22_BWn2A img.eIhG16Mc').attr('src');
                   //
                   //图片列表
                   let _shangjia_images_arr = [];
                   _dom.find('._2AOclWz7 ._3ACovDZO').each(function (){
                       var _img = $(this).find('img').attr('src');
                       if(_img && _img.indexOf("?") !== -1){
                           var _imgarr = _img.split('?')
                           if(_imgarr.length > 1){
                               _shangjia_images_arr.push(_imgarr[0]);
                           }
                       }
                   })
                   need_item['_shangjia_images'] = _shangjia_images_arr.join(',');
                   //
                   need_item['_shangjia_store_name'] = _dom.find('._36F9aw_t ._373TxnaS').text();
                   need_item['_shangjia_store_score'] = _dom.find('._36F9aw_t ._7JDNQb0g').attr('aria-label');
                   let _shangjia_store_url = _dom.find('._36F9aw_t a._3VEjS46S').attr('href');
                   if(_shangjia_store_url && _shangjia_store_url.indexOf('undefined') == -1){
                       need_item['_shangjia_store_url'] = 'https://www.temu.com'+_shangjia_store_url;
                   }
                   need_item['_shangjia_store_followers'] = _dom.find('._36F9aw_t ._2_doduKi ._3NlmlXKl').eq(0).text();
                   need_item['_shangjia_store_sold'] = _dom.find('._36F9aw_t ._2_doduKi ._3NlmlXKl').eq(1).text();
                   need_item['_shangjia_store_items'] = _dom.find('._36F9aw_t ._2_doduKi ._3NlmlXKl').eq(2).text();
                   //
                   need_item['_shangjia_catalog_1'] = _dom.find('.baseContent nav ol li:eq(1)').text();
                   need_item['_shangjia_catalog_2'] = _dom.find('.baseContent nav ol li:eq(2)').text();
                   //
                   if(need_item['_shangjia_store_url']){
                       need_item['_is_request'] = 2;
                   }else{
                       need_item['_is_request'] = 0;
                       need_item['_error'] = 'not found store url';
                       sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                        //
                   }*/
                   //
                   need_item['_e_time'] = Date.now();
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                   /*if(need_item['_shangjia_img']){
                       urlToBase64(need_item['_shangjia_img'], function(base64String) {
                           //console.log(blob);
                            //need_item['_shangjia_img_blob'] = base64String;
                            //
                            need_item['_is_request'] = 2;
                            need_item['_e_time'] = Date.now();
                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                            });
                            //
                        });
                   }*/
                   //
               }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('ajax error');
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_is_request'] = 0;
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                        //

                        //
                });
                //
                pause_s_time();
                sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let binfa = 0;
        for(let key in items){
             if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                 if(items[key]['_is_request'] == 1){
                     binfa++;
                     if(binfa == 5){
                         break;
                     }
                 }
             }
        }
        if(binfa < 5 || true){
          let need_item = null;
          for(let key in items){
                if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                    if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                        need_item = items[key];
                        need_item['_is_request'] = 1;
                        need_item['_s_time'] = Date.now();
                        let obj = {};
                        obj[key] = need_item;
                        chrome.storage.local.set(obj, function (){
                            //
                            request_shangjia_about_contact_and_basic_info_ajax(key);
                            //
                        });
                        break;
                    }
                }
          }
        }
        //
    });
}

function xintiao(){
     chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             //360000
             if(items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+60000) > Date.now()){
                console.log('爬取失败，暂停60s');
             }else{
                 console.log('爬取中');
                 request_shangjia_about_contact_and_basic_info();
             }
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 40000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }

        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                shangjias.push(shangjia_infos[i]['_shangjia_id']);
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_shangjias.length;j++){
                    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        //storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 5000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'can_list_caiji'){
        console.log('can_list_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_list') || items['pause_list'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 5000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = '', url=''){
    //
    if(url){
        console.log('sendPopTips url:'+url);
        chrome.tabs.create({url: url}, function(newTab) {
            // 监听标签页的更新事件
            chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
              // 检查页面是否已完全加载
              if (tabId === newTab.id && changeInfo.status === "complete") {
                // 在这里执行你想要在页面加载完成后执行的操作
                console.log("页面已完全加载");
                //sendResponse(JSON.stringify({}));
                // 你可以继续在这里添加其他代码
              }
            });
          });
    }
    //
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}